org.apache.lucene.index

## Class UpgradeIndexMergePolicy

- java.lang.Object
- - org.apache.lucene.index.MergePolicy
  - - org.apache.lucene.index.FilterMergePolicy
    - - org.apache.lucene.index.UpgradeIndexMergePolicy

-     public class UpgradeIndexMergePolicy
      extends FilterMergePolicy

  This `MergePolicy` is used for upgrading all existing segments of an index when calling `IndexWriter.forceMerge(int)`. All other methods delegate to the base `MergePolicy` given to the constructor. This allows for an as-cheap-as possible upgrade of an older index by only upgrading segments that are created by previous Lucene versions. forceMerge does no longer really merge; it is just used to "forceMerge" older segment versions away.

  In general one would use `IndexUpgrader`, but for a fully customizeable upgrade, you can use this like any other `MergePolicy` and call `IndexWriter.forceMerge(int)`:

        IndexWriterConfig iwc = new IndexWriterConfig(Version.LUCENE_XX, new KeywordAnalyzer());
        iwc.setMergePolicy(new UpgradeIndexMergePolicy(iwc.getMergePolicy()));
        IndexWriter w = new IndexWriter(dir, iwc);
        w.forceMerge(1);
        w.close();

  Warning: This merge policy may reorder documents if the index was partially upgraded before calling forceMerge (e.g., documents were added). If your application relies on "monotonicity" of doc IDs (which means that the order in which the documents were added to the index is preserved), do a forceMerge(1) instead. Please note, the delegate `MergePolicy` may also reorder documents.

  See Also:
    `IndexUpgrader`
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.MergePolicy

      `MergePolicy.MergeAbortedException, MergePolicy.MergeContext, MergePolicy.MergeException, MergePolicy.MergeSpecification, MergePolicy.OneMerge, MergePolicy.OneMergeProgress`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.FilterMergePolicy

      `in`

    - ### Fields inherited from class org.apache.lucene.index.MergePolicy

      `DEFAULT_MAX_CFS_SEGMENT_SIZE, DEFAULT_NO_CFS_RATIO, maxCFSSegmentSize, noCFSRatio`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UpgradeIndexMergePolicy(MergePolicy in)` Wrap the given `MergePolicy` and intercept forceMerge requests to only upgrade segments written with previous Lucene versions.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MergePolicy.MergeSpecification` | `findForcedMerges(SegmentInfos segmentInfos, int maxSegmentCount, Map<SegmentCommitInfo,Boolean> segmentsToMerge, MergePolicy.MergeContext mergeContext)` Determine what set of merge operations is necessary in order to merge to `<=` the specified segment count.
    `MergePolicy.MergeSpecification` | `findMerges(MergeTrigger mergeTrigger, SegmentInfos segmentInfos, MergePolicy.MergeContext mergeContext)` Determine what set of merge operations are now necessary on the index.
    `protected boolean` | `shouldUpgradeSegment(SegmentCommitInfo si)` Returns if the given segment should be upgraded.

    - ### Methods inherited from class org.apache.lucene.index.FilterMergePolicy

      `findForcedDeletesMerges, findFullFlushMerges, getMaxCFSSegmentSizeMB, getNoCFSRatio, keepFullyDeletedSegment, numDeletesToMerge, setMaxCFSSegmentSizeMB, setNoCFSRatio, size, toString, useCompoundFile`

    - ### Methods inherited from class org.apache.lucene.index.MergePolicy

      `assertDelCount, isMerged, message, segString, verbose`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### UpgradeIndexMergePolicy

          public UpgradeIndexMergePolicy(MergePolicy in)

      Wrap the given `MergePolicy` and intercept forceMerge requests to only upgrade segments written with previous Lucene versions.

  - ### Method Detail

    - #### shouldUpgradeSegment

          protected boolean shouldUpgradeSegment(SegmentCommitInfo si)

      Returns if the given segment should be upgraded. The default implementation will return `!Version.LATEST.equals(si.getVersion())`, so all segments created with a different version number than this Lucene version will get upgraded.

    - #### findMerges

          public MergePolicy.MergeSpecification findMerges(MergeTrigger mergeTrigger,
                                                           SegmentInfos segmentInfos,
                                                           MergePolicy.MergeContext mergeContext)
                                                    throws IOException

      Description copied from class: `MergePolicy`
      Determine what set of merge operations are now necessary on the index. `IndexWriter` calls this whenever there is a change to the segments. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.
      Overrides:
        `findMerges` in class `FilterMergePolicy`
      Parameters:
        `mergeTrigger` - the event that triggered the merge
        `segmentInfos` - the total set of segments in the index
        `mergeContext` - the IndexWriter to find the merges on
      Throws:
        `IOException`

    - #### findForcedMerges

          public MergePolicy.MergeSpecification findForcedMerges(SegmentInfos segmentInfos,
                                                                 int maxSegmentCount,
                                                                 Map<SegmentCommitInfo,Boolean> segmentsToMerge,
                                                                 MergePolicy.MergeContext mergeContext)
                                                          throws IOException

      Description copied from class: `MergePolicy`
      Determine what set of merge operations is necessary in order to merge to `<=` the specified segment count. `IndexWriter` calls this when its `IndexWriter.forceMerge(int)` method is called. This call is always synchronized on the `IndexWriter` instance so only one thread at a time will call this method.
      Overrides:
        `findForcedMerges` in class `FilterMergePolicy`
      Parameters:
        `segmentInfos` - the total set of segments in the index
        `maxSegmentCount` - requested maximum number of segments in the index (currently this is always 1)
        `segmentsToMerge` - contains the specific SegmentInfo instances that must be merged away. This may be a subset of all SegmentInfos. If the value is True for a given SegmentInfo, that means this segment was an original segment present in the to-be-merged index; else, it was a segment produced by a cascaded merge.
        `mergeContext` - the MergeContext to find the merges on
      Throws:
        `IOException`

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.